;;;;;;;;;;;;;;;;;; TEST of ann ;;;;;;;;;;;;;;;;;;;

;;;;; 1) First try some boundary cases

;;;;;;;;;; a) Annihilator of (0):

<ring 4 a-d r
poly f 0
<ann
<ann f g
type g
; should be "1"
betti g
; correct answer is  0:   1

;;;;;;;;;; b) Annihilator of (1):

poly f 1
<ann f g
type g
; should be nothing (= 0)
betti g

;;;;;;;;;; c) Annihilator of an empty matrix:

<zeromat 0 10 f
<ann f g
type g
betti g

kill r'zero r f g

;;;;; 2) Now some true examples

;;;;;;;;;; a) Annihilator of a cat. matrix

<ring 3 a-z r
cat a m
0 -1
0..3
type m
; should be:
; a b c 0
; 0 a b c
<ann m i
type i
; should be: (a,b,c)2

std m m
elim m em 1
type em
putstd m em
type em

kill r'zero r m em

;;;;;;;;;; b) Now try the maxdegree option

<ring 2 a-z r
<ideal j a3 b4
dshift j -6
<ann j k 0
type k
betti k

<ring 2 a-z r
<ideal j a3 b4 1
dshift j -6
<ann j k 0
type k
betti k

kill r'zero r j k
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;; 3) Comparison of the three methods (i.e. ann, ann1, ann2):

;    In these examples, ann2 is usually faster than ann1,
; but ann is fastest on all the larger problems we have
; tried, in some cases quite dramatically.
;    Note also that ann2 introduces new variables which
; appear to a degree about the number of rows of the original
; presentation -- impractical when the matrices are large as in
; one example below.

<ring 11 a-z r
cat a n
0..3
0..8

type n
;<ann1 n ann
;type ann
;Ann1 did not finish after 6 min on 50Mhz Mac II

<ann2 n ann
numinfo ann
;about 3:15 min on 50 Mhz Mac*II
<ann n ann
numinfo ann
;about 4 min on 50 Mhz Mac*II

kill r'zero r n ann
; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;; 4) Yet an example of the strong form of Huneke's conj:

<ring 3 a-z r
power r 2 r2
res r2 rr
transpose rr.2 t
<wedgecok t 4 t4
betti t4
; correct answer:
; total:     70   336
; --------------------
;   -12:     70   336
;<ann1 t4 i
;About 1 hour on the Decstation 5000 (only 2.7 Mbytes)

homog t4 a t4
<ann t4 i
;About 3 minutes on 50 Mhz MacII
type i
;should be: "b a c"

;;;;; 5) Further examples for strong Huneke conjecture. All but the first
;;;;;    was too hard with ann1, impossible with ann2.

<ring 4 a-z r
<ideal i a2 b2 c2 d2 abcd
res i ii
betti ii

<rankprob ii.1 r1
<wedgecok ii.2 r1+1 w1
betti w1
; total:     10    50
; --------------------
;     4:      6     -
;     5:      -    24
;     6:      4    16
;     7:      -     6
;     8:      -     4

;<ann1 w1 i1
;<ann2 w1 i1
homog w1 a w1  ;it seems that w1 is not homogeneous
<ann w1 i1
;takes about 3 sec

<rankprob ii.2 r2
<wedgecok ii.3 r2+1 w2
betti w2
; total:    252  2100
; --------------------
;    20:      6     -
;    21:     60   150
;    22:    120   800
;    23:     60   900
;    24:      6   240
;    25:      -    10
;About 1000 of the columns are minimal generators
;<ann1 w2 i2
;<ann2 w2 i2
homog w2 a w2
<ann w2 i2
;takes 3:25 min on 50 Mhz MacII
type i2
;d2 a2 c2 b2 abcd

<rankprob ii.3 r3
<wedgecok ii.4 r3+1 w3
betti w3
; total:    120   840
; --------------------
;    42:    120   840
homog w3 a w3
<ann w3 i3
;takes about a minute on 50 Mhz MacII
type i3
;should be: d c a b

listvars
;;;;;;;;;;;;;;;;;;;;; END test of ann ;;;;;;;;;;;;;;;;;;;;;;
reset
$


