;;;;;;;;;;;;;;;;;;;;;; TEST of cotbihom ;;;;;;;;;;;;;;;;;;;;

; The cotangent sheaf of P2 embedded as the diag in P2 x P2

<ring 6 stuxyz r

; the ideal of the diagonal:
<genermat s 2 3 i
type i
wedge i 2 i2
flatten i2 i2
type i2

<cotbihom
<cotbihom s..u x..z i2 Om
<prune Om Om
res Om Om
betti Om
; correct answer:
; total:      9    22    18     6     1
; --------------------------------------
;     2:      9    22    18     6     1
;Note depth 2 with respect to the maximal ideal.
;An unusual view of the cotangent sheaf!
;The meaning is:  O(a,b) on P2xP2 restricts to O(a+b) on P2;
;and "total degree 2" over the bihomogeneous ring is the sum of
;bidegrees (2,0), (1,1), and (0,2).  So the fact that
;        h^0 ( Omega_{P2}(1) ) = 0
;shows that Omega as a bigraded module will be 0 in total degree1,
;while in total degree 2 it will consist of 3 copies of
;        H^0 ( Omega_{P2}(2) ) ,
;which is 3-dimensional, for a total of 9 dimensions, as shown.

listvars
;;;;;;;;;;;;;;;;;;;;; END test of cotbihom ;;;;;;;;;;;;;;;;;
reset
$

