;;;;;;;;;;;;;;;;;;; TEST of extring ;;;;;;;;;;;;;;;;;;;;

;Normalization in P4 of the smooth rational quartic in P3

;Form the coordinate ring R of the quartic:
<ring 4 a-d s
<monomcur 1 3 4 i
std i i
qring i R

;Next make a test ideal j:
<powers R 2 j

<extring
<extring j x S
present-ring S K

;Note that K is an ideal in a polynomial ring over R,
;which is not itself a polynomial ring.  In fact, the
;number of minimal generators of K is only 5, since
;one of the quadrics in the ideal is 0 in R!  We can
;get everything up to a polynomial ring to look at it as
;follows:

present-ring K L
setring L
fetch K K1
concat L K1
nres L L
betti L
; correct answer:
; --------------------------------
;     0:      1     -     -     -
;     1:      -     6     8     3

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;The ideal of a smooth rational quintic in P3:

<ring 4 a-d s
<monomcur 1 4 5 i
std i i
qring i R

;Next make a test ideal j:
<powers R 4 j

<extring j x S
present-ring S K

;Note that K is an ideal in a polynomial ring over R,
;which is not itself a polynomial ring.  We can
;get everything up to a polynomial ring to look at it as
;follows:

present-ring K L
setring L
fetch K K1
concat L K1
nres L L
betti L
hilb L.1
; correct answer:
; total:      1    10    20    15     4
; --------------------------------------
;     0:      1     -     -     -     -
;     1:      -    10    20    15     4

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;The ideal of an (arith genus 2) rational quintic (2 ordinary cusps):

; <extring gives a warning in this
;    case, essentially because there's nothing to add.

<ring 4 a-d s
<monomcur 1 3 5 i
std i i
qring i R

;Next make a test ideal j:
<powers R 4 j

<extring j x S
present-ring S K

;Note that K is an ideal in a polynomial ring over R,
;which is not itself a polynomial ring.  We can
;get everything up to a polynomial ring to look at it as
;follows:

present-ring K L
setring L
fetch K K1
concat L K1
nres L L
betti L

listvars
;;;;;;;;;;;;;;;;;;; END test of extring ;;;;;;;;;;;;;;;;;
reset
$


