;;;;;;;;;;;;;;;;;;;; TEST of normalsh ;;;;;;;;;;;;;;;;

; 1) Normal bundle of a complete intersection:

<ring 4 a-z r
<ideal i a2+b2+c2+d2 a2-b2
<normalsh
<normalsh i N Nbar
betti N

;alternately
<ideal i a2+b2+c2+d2 a2-b2
res i ii 2
<hom ii.2 ii.1 N
betti N

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

; 2) Normal bundle of the twisted cubic:

<ring 4 a-z r
<monomcur 1 2 3 i ;the twisted cubic
<normalsh i N Nbar
std N N ;
betti N
; correct answer:
; total:      6    12
; --------------------
;    -1:      6    12
;The normal bundle is
;0_{P1}^2 (5) = 0_{P3} (1)  \0  0_{P1}^2 (2),
;where we have written \0 for tensor.
;Thus, up to a shift of degree by 1, the resolution is the resolution
;over P3 of 0_{P1}^2 (2), and this has 6 sections.
;H^0 (N) = dimension of the hilbert scheme = 12,
;since this is a smooth point:
k-basis N b
0
0
betti b
; should be:
; total:      6    12
; --------------------
;    -1:      6    12
;Answer is in the second column = 12.
;Note that this 12 is the complementary 12 to the 12 relations of n
;(since 4 x 6 = 24.)

;alternately
res i ii 2
<hom ii.2 ii.1 N
betti N

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

; 3) A canonically embedded graph curve

;A graph curve of genus 7, from work of Ciliberto and ...
<ring 7 a-z r
;This comes from a planar graph pg7.
ideal i
 10
 ef-eg
 cf+df
 cd-ce-cg
 be
 bd-bg
 bc+bg
 af+df
 ad-ae-ag
 ac+ae+ag
 ab+df+ag

res i ii
betti ii
; correct answer:
; total:      1    10    21    21    10     1
; --------------------------------------------
;     0:      1     -     -     -     -     -
;     1:      -    10    16     5     -     -
;     2:      -     -     5    16    10     -
;     3:      -     -     -     -     -     1
;genus 7, Clifford index 2
<normalsh i N p
std N N
betti N
; correct answer:
; total:     20    98
; --------------------
;    -1:     16    50
;     0:      4    48
;H^0 (N) = dimension of the hilbert scheme = 12,
;since this is a smooth point:
k-basis N b
-1
0
betti b
; correct answer:
;    -2:      -    16
;    -1:     16    66
;     0:      4     -
;So h^0 N(-1) = 16, h^0 (N) = 66 = 3*7 - 3 + 7^2 - 1
;= the dim of hilb.

;The alternate method takes about 5 times as long:
res i ii 2
<hom ii.2 ii.1 N
betti N
;Not a minimal presentation.
;OK after pruning.
; correct answer:
; total:     72   150
; --------------------
;    -1:     16   102
;     0:     56    48

k-basis N b
-1
0
betti b
; correct answer:
; total:     72    82
; --------------------
;    -2:      -    16
;    -1:     16    66
;     0:     56     -

listvars
;;;;;;;;;;;;;;;;;;;; END test of normalsh ;;;;;;;;;;;;;;;;;;;
reset
$


