;;;;;;;;;;;;;;;;;;;; TEST of projprod ;;;;;;;;;;;;;;;;;;;;;;;;;

; Computing the dual of a plane curve f=0:

;The ring of P2xP2
ring r
;
6
abcxyz
;
3 3

; a) The nonsingular cubic
poly f a3+b3+c3
jacob f j a..z
type j
transpose j j'

;form the row of variables of the second factor
setring r
<getvars vars
elim vars vars2

;Now form the graph of the Gauss map
transpose vars2 vars2'
concat j' vars2'
wedge j' 2 i
flatten i i
concat i f

;and project
<projprod
<projprod i 3 k  ;This takes a while!
type k
;should be: a6-2a3b3+b6-2a3c3-2b3c3+c6

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

; b) The cuspidal cubic:

;The ring of P2xP2
ring r
;
6
abcxyz
;
3 3

poly f a2c-b3
jacob f j a..z
type j
transpose j j'

;form the row of variables of the second factor
<getvars vars
elim vars vars2

;Now form the graph of the Gauss map
transpose vars2 vars2'
concat j' vars2'
wedge j' 2 i
flatten i i
concat i f
type i

;Remove the components coming from the singular locus
;Note that we get sing x (everything) in the graph,
;so that if we remove this step the resulting ideal k = 0.
<sat i j i

;and project
<projprod i 3 k
type k
;The dual is again a cuspidal cubic.

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

; c) The nodal cubic:

;The ring of P2xP2
ring r
;
6
abcxyz
;
3 3
poly f a2c-b2(b-c)
jacob f j a..z
type j
transpose j j'

;form the row of variables of the second factor
<getvars vars
elim vars vars2

;Now form the graph of the Gauss map
transpose vars2 vars2'
concat j' vars2'
wedge j' 2 i
flatten i i
concat i f

;Remove the components coming from the singular locus
<sat i j i

;and project
<projprod i 3 k
type k
;should be: a4+2a2b2+b4+9a2bc+b3c+27/4a2c2

;Take the dual of k:
copy k f

jacob f j a..z
type j
transpose j j'

;form the row of variables of the second factor
<getvars vars
elim vars vars2

;Now form the graph of the Gauss map
transpose vars2 vars2'
concat j' vars2'
wedge j' 2 i
flatten i i
concat i f

;Remove the components coming from the singular locus
<sat i j i

;and project
<projprod i 3 k
type k
;should be: b3-a2c+b2c ;The original polynomial!!!

listvars
;;;;;;;;;;;;;;;;;;;; END test of projprod ;;;;;;;;;;;;;;;;
reset
$


