;;;;;;;;;;;;;;;;;; TEST of ratnorcu ;;;;;;;;;;;;;;;;;;;

<ring 4 a-z r
<colvect P 1 2 4
type P

<ratnorcu
<ratnorcu P i m
type i
type m

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;a canonical curve in P5 as the union of two
;rational normal curves through the coordinate points:

<ring 6 a-z r
<colvect P 1 2 3 4 5 6
<colvect Q 1 4 6 8 10 12
;Note that these two are colinear with 1 0 0 0 0 0,
;so not all 3 can lie on a RNC.

<ratnorcu P i
<ratnorcu Q j
intersect i j k
res k kk
betti kk
; correct answer:
; total:      1     9    16     9     1
; --------------------------------------
;     0:      1     -     -     -     -
;     1:      -     6     8     3     -
;     2:      -     3     8     6     -
;     3:      -     -     -     -     1
;NOTE that this is trigonal -- because of the colinearity?

res i ii
betti ii
; correct answer:
; total:      1    10    20    15     4
; --------------------------------------
;     0:      1     -     -     -     -
;     1:      -    10    20    15     4

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

; a random example:

<ring 6 a-z r
random 6 1 P
random 6 1 Q
<ratnorcu P i
<ratnorcu Q j
intersect i j k
<res k kk 4 verbose ;res is too slow!
betti kk
; correct answer:
; total:      1     6    10     6     1
; --------------------------------------
;     0:      1     -     -     -     -
;     1:      -     6     5     -     -
;     2:      -     -     5     6     -
;     3:      -     -     -     -     1

;Note that we get the general Clifford index in this case

listvars
;;;;;;;;;;;;;;;;;; END test of ratnorcu ;;;;;;;;;;;;;;;;;
reset
$


